-- Author      : Nogarder
-- Create Date : 2015/3/9 21:43:44
local pairs=pairs
local table_getn=table.getn
--create
local parent=RS.OptionsMain
local textlist=RS.Template.CreateFrame(parent,1,1,nil,true)
textlist:EnableMouse(false)
--background--black
textlist.Background=RS.Template.CreateBackground(textlist,nil,0,1)
--buttonlist
textlist.Texts={}
--
local RS_Template_TextList_UpdateTextList=function(data)
	--set display
	local maxwidth=10
	local step=textlist.TextHeight
	local texts=textlist.Texts
	local max=table_getn(data)
	for i=1,max do
		local unit=data[i]
		if(not texts[i])then
			texts[i]=RS.Template.CreateText(textlist," ")
		end
		--
		texts[i]:SetPoint("BOTTOMLEFT",textlist,"TOPLEFT",3+(unit.Offset or 0),-i*step)
		--
		texts[i]:SetText(unit.Text)
		--
		texts[i]:Show()

		local width=texts[i]:GetWidth()+6+unit.Offset
		if(maxwidth<width)then
			maxwidth=width
		end
	end
	for i=max+1,table_getn(texts)do
		texts[i]:Hide()
	end
	--set frame width and height
	textlist:SetWidth(maxwidth)
	--
	local height=step*max+3
	textlist:SetHeight(height)
	--show
	textlist:Show()
end
--
RS.Template.SetTextList=function(dparent,width,data,mainframe,textheight)
	textlist:Hide()
	--data={
	--	[index]={
	--		Text=<text>,
	--		Offset=<offset>
	--		}
	textlist:ClearAllPoints()
	textlist.Parent=dparent
	textlist:SetParent(mainframe or parent)
	textlist:SetFrameLevel(parent:GetFrameLevel()+3)
	--init
	textlist.TextHeight=buttonheight or 15
	RS_Template_TextList_UpdateTextList(data)
	--
	RS.Animation.ShowFrame(textlist)
	--
	return textlist
end


RS.Template.HideTextList=function()
	RS.Animation.HideFrame(textlist)
end
RS.RegisterTemplate(textlist,function()
	textlist:Hide()
end)

--
RS.RegisterTemplate(textlist,RS.Template.HideTextList)
